SystemOrganization addCategory: #Mercury!

MCTool subclass: #Mercury
	instanceVariableNames: 'textPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mercury'!

!Mercury class methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:28'!
initialize
	 (TheWorldMenu respondsTo: #registerOpenCommand:)
         ifTrue: [TheWorldMenu registerOpenCommand: {'Mercury'. {self. #open}}]! !

!Mercury class methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:28'!
open
	self new show! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:02'!
browse: aSymbol
	(Smalltalk classNamed: aSymbol) ifNotNilDo: [:c | self systemNavigation browseClass: c]! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:02'!
classRefs: aSymbol
	(Smalltalk classNamed: aSymbol) ifNotNilDo:
		[:c | self systemNavigation browseAllCallsOnClass: c]! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:27'!
defaultExtent
	^ (400 @ 15)! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:07'!
findClass: aString
	self systemNavigation browseClassesWithNamesContaining: aString caseSensitive: false! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:06'!
findMethod: aString
	self systemNavigation browseMethodsWhoseNamesContain: aString! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:03'!
implementors: aSymbol
	self systemNavigation browseAllImplementorsOf: aSymbol! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:25'!
initialize
	super initialize.
	(self window submorphs second instVarNamed: 'textMorph') acceptOnCR: true! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:17'!
response
	^ ''! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:25'!
response: aString
	self search: aString asString.
	self window submorphs second update: #response! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:06'!
search: aString
	|refs literal tokens wildcard |
	tokens _ Scanner new scanTokens: aString.
	literal _ tokens at: 1 ifAbsent: [^ self].
	wildcard _ (tokens at: 2 ifAbsent: []) = #*.
	refs _ aString withBlanksTrimmed first = $#.
	literal isSymbol ifTrue:
		[literal first isUppercase ifTrue:
			[wildcard ifTrue:
				[self findClass: literal]
			ifFalse:
				[refs ifTrue: [self classRefs: literal] ifFalse: [self browse: literal]]]
		ifFalse:
			[wildcard ifTrue:
				[self findMethod: literal]
			ifFalse:
				[refs ifTrue: [self senders: literal] ifFalse: [self implementors: literal]]]]
	ifFalse: [self string: literal]! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:03'!
senders: aSymbol
	self systemNavigation browseAllCallsOn: aSymbol! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:07'!
string: aString
	self systemNavigation browseMethodsWithString: aString! !

!Mercury methodsFor: 'as yet unclassified' stamp: 'avi 1/26/2007 00:19'!
widgetSpecs
	^ #(((textMorph: response) (0 0 1 1)))! !
Mercury initialize!
